Codeforces Round #276 (Div. 1)

Codeforces 484 A. Bits

做题感悟:这题不难,是一个构造题,找一下规律就好。

解题思路:

假如两个数的二进制位数分别是 a ,b.(这里假设 a < b)  , 当 b - a >= 1 时只有两种情况可以选择 (1 << b) - 1  or  (1<<a) -1  ,这里当然先判断前一个是否满足,当 a = b 的时候,枚举两个数的每一位,如果出现小的数当前位为 0 ,且大的数当前位为 1 ,那么也有两种情况选择要么当前位加上后面的所有位都为 1  ,要么后面的位全为 1 ,这里也先判断前一种情况。开始的时候要特判一下两个数相等的情况。注意:(1<<b)的时候
1 要替换成 __int64 的变量。

代码:

#include<iostream>
#include<sstream>
#include<map>
#include<cmath>
#include<fstream>
#include<queue>
#include<vector>
#include<sstream>
#include<cstring>
#include<cstdio>
#include<stack>
#include<bitset>
#include<ctime>
#include<string>
#include<cctype>
#include<iomanip>
#include<algorithm>
using namespace std  ;
#define INT __int64
#define L(x)  (x * 2)
#define R(x)  (x * 2 + 1)
const int INF = 0x3f3f3f3f ;
const double esp = 0.0000000001 ;
const double PI = acos(-1.0) ;
const int mod = 1000000007 ;
const int MY = (1<<5) + 5 ;
const int MX = 200000 + 5 ;
const int S = 20 ;
INT Le ,Rt ;
INT judge(INT S)
{
    if(!S) return 1 ;
    INT temp = 1 ;
    for(INT i = 63 ;i >= 0 ; --i)
       if(S&(temp<<i))
          return i+temp ;
}
int main()
{
    INT Tx ,a1 ,a2 ;
    scanf("%I64d" ,&Tx) ;
    while(Tx--)
    {
        scanf("%I64d%I64d" ,&Le ,&Rt) ;
        a1 = judge(Le) ;
        a2 = judge(Rt) ;
        if(Le == Rt)
        {
            cout<<Le<<endl ;
            continue ;
        }
        INT tx ,temp ,A = 1 ;
        if(a2 == a1)
        {
           temp = 0 ;
           for(INT i = a1-A ;i >= 0 ; --i)
           {
               if(!(Le&(A<<i)) && (Rt&(A<<i)))
               {
                   tx = temp ;
                   tx += (A<<(i+1)) - A ;
                   if(tx >= Le && tx <= Rt)
                            cout<<tx<<endl ;
                   else
                   {
                       temp += (A<<i) -A ;
                       cout<<temp<<endl ;
                   }
                   break ;
               }
               if(Le&(A<<i))  temp += (A<<i) ;
           }
        }
        else
        {
            INT temp = (A<<a2) - A ;
            if(temp > Rt)
                    cout<<((A<<(a2-A))-A)<<endl ;
            else    cout<<temp<<endl ;
        }
    }
    return 0 ;
}

484 B. Maximum Value

做题感悟:这题真没向二分方向考虑,只考虑到与倍数相差尽量小,二分大法好!

解题思路:

方法一 、 如果要使 a [ i ]  % a [ j ] 尽量大,我们可以找 小于 k * a[ j ] 且最接近这个数的数,那么对 a [ j ] 取模与其它数相比一定更优。优化:从大到小枚举,这样每次判断最优值,如果a [ j ] - 1 不大于最优解就  break ;

方法二、类似筛法的思想,其实和第一种差不多,都是找最接近 k * a [ j ] 的数,具体见代码。

代码:

#include<iostream>
#include<sstream>
#include<map>
#include<cmath>
#include<fstream>
#include<queue>
#include<vector>
#include<sstream>
#include<cstring>
#include<cstdio>
#include<stack>
#include<bitset>
#include<ctime>
#include<string>
#include<cctype>
#include<iomanip>
#include<algorithm>
using namespace std  ;
#define INT __int64
#define L(x)  (x * 2)
#define R(x)  (x * 2 + 1)
const int INF = 0x3f3f3f3f ;
const double esp = 0.0000000001 ;
const double PI = acos(-1.0) ;
const int mod = 1000000007 ;
const int MY = (1<<13) + 5 ;
const int MX = 200000 + 5 ;
const int MS = 2000000 ;
int n ;
int g[MX] ;
int main()
{
    //freopen("input.txt" ,"r" ,stdin) ;
    while(~scanf("%d" ,&n))
    {
        for(int i = 0 ;i < n ; ++i)
          scanf("%d" ,&g[i]) ;
        sort(g ,g+n) ;
        n = unique(g ,g+n) - g ;
        int ans = 0 ;
        for(int i = n - 1 ;i >= 0 ; --i)
        {
            if(ans >= g[i]-1)  break ;
            for(int j = 2 ; ; ++j)
            {
                int mx = lower_bound(g ,g+n ,g[i]*j) - g ;
                ans = max(ans ,(g[mx-1])%g[i]) ;
                if(mx >= n)  break ;
            }
        }
        printf("%d\n" ,ans) ;
    }
    return 0 ;
}

代码:

#include<iostream>
#include<sstream>
#include<map>
#include<cmath>
#include<fstream>
#include<queue>
#include<vector>
#include<sstream>
#include<cstring>
#include<cstdio>
#include<stack>
#include<bitset>
#include<ctime>
#include<string>
#include<cctype>
#include<iomanip>
#include<algorithm>
using namespace std  ;
#define INT __int64
#define L(x)  (x * 2)
#define R(x)  (x * 2 + 1)
const int INF = 0x3f3f3f3f ;
const double esp = 0.0000000001 ;
const double PI = acos(-1.0) ;
const int mod = 1000000007 ;
const int MY = (1<<13) + 5 ;
const int MX = 200000 + 5 ;
const int MS = 2000000 ;
int n ;
int g[MS] ;
int main()
{
    int x ;
    while(~scanf("%d" ,&n))
    {
        g[0] = 1 ;
        for(int i = 0 ;i < n ; ++i)
        {
            scanf("%d" ,&x) ;
            g[x] = x ;
        }
        for(int i = 1 ;i <= MS ; ++i)
          if(g[i] != i)
              g[i] = g[i-1] ;
        int ans = 0 ;
        for(int i = 1 ;i <= MS ; ++i)
           if(g[i] == i)
           {
               for(int j = i*2 ;j <= MS ; j = j+i)
                   ans = max(ans ,g[j-1]%i) ;
           }
        cout<<ans<<endl ;
    }
    return 0 ;
}

时间: 2024-10-14 00:36:31

Codeforces Round #276 (Div. 1)的相关文章

Codeforces Round #276 (Div. 1) A. Bits 贪心

A. Bits Let's denote as  the number of bits set ('1' bits) in the binary representation of the non-negative integer x. You are given multiple queries consisting of pairs of integers l and r. For each query, find the x, such that l ≤ x ≤ r, and is max

Codeforces Round #276 (Div. 2)C. Bits(构造法)

这道题直接去构造答案即可. 对于l的二进制表示,从右到左一位一位的使其变为1,当不能再变了(再变l就大于r了)时,答案就是l. 这种方法既可以保证答案大于等于l且小于等于r,也可以保证二进制表示时的1最多. #include<iostream> #include<cstdio> #include<cstdlib> #include<cstring> #include<string> #include<cmath> #include&l

Codeforces Round #276 (Div. 1)D.Kindergarten DP贪心

D. Kindergarten In a kindergarten, the children are being divided into groups. The teacher put the children in a line and associated each child with his or her integer charisma value. Each child should go to exactly one group. Each group should be a

Codeforces Round #276 (Div. 2)D - Maximum Value(筛法)

就是一种筛法思想的应用. #include<iostream> #include<cstdio> #include<cstdlib> #include<cstring> #include<string> #include<cmath> #include<map> #include<set> #include<vector> #include<algorithm> #include<

Codeforces Round #276 (Div.1) Solution

水平越来越菜了 A  水题,注意后面全是1的情况 B  调和级数呀.把倍数全部扫一遍.一个数是多个数的倍数的话肯定是大的比较优.然后可以用two pointer扫一下. C  就是一个置换群,把轮换找出来就好了.傻逼的写了好久. D  有意思的傻逼DP,容易得到dp[i] = max{dp[j] + max{abs(a[k]-a[h])}} .只要更新一个U = max{a[i] + max_{0~(i-1)}{dp[i]}}和D = max{-a[i] + max_{0~(i-1)}{dp[i

Codeforces Round #276 (Div. 2)A. Factory(数论)

这道题可以暴力的一直按要求的方法去做,做1000000次还不能整除m就认为永远不能整除m了(m不超过100000,循环1000000次比较安全了已经).这种方法可以AC. 下面深入的分析一下到底循环多少次就可以确定结果:首先有这样一个规律:(a+b)%c=(a%c+b%c)%c,那么这样其实这道题每次就是2*a.官方题解说的好: Production will stops iff exists integer K ≥ 0 such a·2K is divisible by m. From thi

Codeforces Round #276 (Div. 1)Maximum Value

题意很好理解,就是让你搞到两个数a[i],a[j]使得a[i]>a[j]且a[i]%a[j]最大,然后把最大值输出来. 然后,我就开始乱搞了,时间复杂度有点高,O(n*sqrt(max(a[i])); 很容易得出一个结论 如果a[i]>a[j]且a[i]/p==a[j]/p那么a[j]%p>a[j]%p. 那么就开始乱搞了枚举p,如果全部枚举了复杂度就变成O(n*max(a[i]))了. 我们可以只枚举p*p<a[i]的部分,剩下的肯定是连续的1.2.3.4...p.语文不好,不知

C. Bits (Codeforces Round #276 (Div. 2) )

题目大意:给你两个数l,r(l<r),求一个数是大于等于l且小于等于r的数中二进制数的1的个数最多,如果1的个数相同则取最小的那个(翻译渣,请见谅!) 思路:把左区间L化为二进制,再把左区间的二进制的从最小位开始,每位变为1,因为这是在当前1的个数中最小的且大于L的.条件是小于等于右区间R. 代码: 1 #include <iostream> 2 #include <cstdio> 3 #include <cstdlib> 4 #include <stdio

codeforces 484C Strange Sorting Codeforces Round #276 (Div. 1) C

思路:首先 他是对1到k 元素做一次变换,然后对2到k+1个元素做一次变化....依次做完. 如果我们对1到k个元素做完一次变换后,把整个数组循环左移一个.那么第二次还是对1 到 k个元素做和第一次一样的变换,再左移,再对1 到 k个元素做和第一次一样的变换,依次做完n-k+1即可. 假设题目要求的变换为C    循环左移变换为P.那么对于每次查询 相当于做  n-k+1  (CP) 变换.最后把答案再向右移动n-k+1  回到原来位置即可. 那么问题就解决了   效率    每次查询n log